/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookAdsConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookAdsConnectorForm{}

// FacebookAdsConnectorForm struct for FacebookAdsConnectorForm
type FacebookAdsConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Authorizer ID
	OAuthId string `json:"oAuthId"`
	// Label of the source
	Label string `json:"label"`
	// Facebook Ads Account ID.
	AccountId string `json:"accountId"`
	// Facebook campaign ID
	CampaignId *string `json:"campaignId,omitempty"`
	// Facebook Ad Set Id
	AdSetId *string `json:"adSetId,omitempty"`
	// Data range expression
	DateRange string `json:"dateRange"`
	// Time break-up
	TimeBreakup string `json:"timeBreakup"`
	// Reporting level
	Level string `json:"level"`
	// Metrics
	Metric []string `json:"metric"`
	// Breakdown
	Breakdown []string `json:"breakdown,omitempty"`
	// Data labels
	DataLabel []string `json:"dataLabel"`
}

// NewFacebookAdsConnectorForm instantiates a new FacebookAdsConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookAdsConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, accountId string, dateRange string, timeBreakup string, level string, metric []string, dataLabel []string) *FacebookAdsConnectorForm {
	this := FacebookAdsConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.AccountId = accountId
	this.DateRange = dateRange
	this.TimeBreakup = timeBreakup
	this.Level = level
	this.Metric = metric
	this.DataLabel = dataLabel
	return &this
}

// NewFacebookAdsConnectorFormWithDefaults instantiates a new FacebookAdsConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookAdsConnectorFormWithDefaults() *FacebookAdsConnectorForm {
	this := FacebookAdsConnectorForm{}
	var timeBreakup string = "all_days"
	this.TimeBreakup = timeBreakup
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *FacebookAdsConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *FacebookAdsConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *FacebookAdsConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *FacebookAdsConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *FacebookAdsConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *FacebookAdsConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *FacebookAdsConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *FacebookAdsConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *FacebookAdsConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *FacebookAdsConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *FacebookAdsConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *FacebookAdsConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *FacebookAdsConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetAccountId returns the AccountId field value
func (o *FacebookAdsConnectorForm) GetAccountId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetAccountIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AccountId, true
}

// SetAccountId sets field value
func (o *FacebookAdsConnectorForm) SetAccountId(v string) {
	o.AccountId = v
}

// GetCampaignId returns the CampaignId field value if set, zero value otherwise.
func (o *FacebookAdsConnectorForm) GetCampaignId() string {
	if o == nil || IsNil(o.CampaignId) {
		var ret string
		return ret
	}
	return *o.CampaignId
}

// GetCampaignIdOk returns a tuple with the CampaignId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetCampaignIdOk() (*string, bool) {
	if o == nil || IsNil(o.CampaignId) {
		return nil, false
	}
	return o.CampaignId, true
}

// HasCampaignId returns a boolean if a field has been set.
func (o *FacebookAdsConnectorForm) HasCampaignId() bool {
	if o != nil && !IsNil(o.CampaignId) {
		return true
	}

	return false
}

// SetCampaignId gets a reference to the given string and assigns it to the CampaignId field.
func (o *FacebookAdsConnectorForm) SetCampaignId(v string) {
	o.CampaignId = &v
}

// GetAdSetId returns the AdSetId field value if set, zero value otherwise.
func (o *FacebookAdsConnectorForm) GetAdSetId() string {
	if o == nil || IsNil(o.AdSetId) {
		var ret string
		return ret
	}
	return *o.AdSetId
}

// GetAdSetIdOk returns a tuple with the AdSetId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetAdSetIdOk() (*string, bool) {
	if o == nil || IsNil(o.AdSetId) {
		return nil, false
	}
	return o.AdSetId, true
}

// HasAdSetId returns a boolean if a field has been set.
func (o *FacebookAdsConnectorForm) HasAdSetId() bool {
	if o != nil && !IsNil(o.AdSetId) {
		return true
	}

	return false
}

// SetAdSetId gets a reference to the given string and assigns it to the AdSetId field.
func (o *FacebookAdsConnectorForm) SetAdSetId(v string) {
	o.AdSetId = &v
}

// GetDateRange returns the DateRange field value
func (o *FacebookAdsConnectorForm) GetDateRange() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DateRange, true
}

// SetDateRange sets field value
func (o *FacebookAdsConnectorForm) SetDateRange(v string) {
	o.DateRange = v
}

// GetTimeBreakup returns the TimeBreakup field value
func (o *FacebookAdsConnectorForm) GetTimeBreakup() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TimeBreakup
}

// GetTimeBreakupOk returns a tuple with the TimeBreakup field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetTimeBreakupOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TimeBreakup, true
}

// SetTimeBreakup sets field value
func (o *FacebookAdsConnectorForm) SetTimeBreakup(v string) {
	o.TimeBreakup = v
}

// GetLevel returns the Level field value
func (o *FacebookAdsConnectorForm) GetLevel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Level
}

// GetLevelOk returns a tuple with the Level field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetLevelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Level, true
}

// SetLevel sets field value
func (o *FacebookAdsConnectorForm) SetLevel(v string) {
	o.Level = v
}

// GetMetric returns the Metric field value
func (o *FacebookAdsConnectorForm) GetMetric() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetMetricOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Metric, true
}

// SetMetric sets field value
func (o *FacebookAdsConnectorForm) SetMetric(v []string) {
	o.Metric = v
}

// GetBreakdown returns the Breakdown field value if set, zero value otherwise.
func (o *FacebookAdsConnectorForm) GetBreakdown() []string {
	if o == nil || IsNil(o.Breakdown) {
		var ret []string
		return ret
	}
	return o.Breakdown
}

// GetBreakdownOk returns a tuple with the Breakdown field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetBreakdownOk() ([]string, bool) {
	if o == nil || IsNil(o.Breakdown) {
		return nil, false
	}
	return o.Breakdown, true
}

// HasBreakdown returns a boolean if a field has been set.
func (o *FacebookAdsConnectorForm) HasBreakdown() bool {
	if o != nil && !IsNil(o.Breakdown) {
		return true
	}

	return false
}

// SetBreakdown gets a reference to the given []string and assigns it to the Breakdown field.
func (o *FacebookAdsConnectorForm) SetBreakdown(v []string) {
	o.Breakdown = v
}

// GetDataLabel returns the DataLabel field value
func (o *FacebookAdsConnectorForm) GetDataLabel() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value
// and a boolean to check if the value has been set.
func (o *FacebookAdsConnectorForm) GetDataLabelOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DataLabel, true
}

// SetDataLabel sets field value
func (o *FacebookAdsConnectorForm) SetDataLabel(v []string) {
	o.DataLabel = v
}

func (o FacebookAdsConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookAdsConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["accountId"] = o.AccountId
	if !IsNil(o.CampaignId) {
		toSerialize["campaignId"] = o.CampaignId
	}
	if !IsNil(o.AdSetId) {
		toSerialize["adSetId"] = o.AdSetId
	}
	toSerialize["dateRange"] = o.DateRange
	toSerialize["timeBreakup"] = o.TimeBreakup
	toSerialize["level"] = o.Level
	toSerialize["metric"] = o.Metric
	if !IsNil(o.Breakdown) {
		toSerialize["breakdown"] = o.Breakdown
	}
	toSerialize["dataLabel"] = o.DataLabel
	return toSerialize, nil
}

type NullableFacebookAdsConnectorForm struct {
	value *FacebookAdsConnectorForm
	isSet bool
}

func (v NullableFacebookAdsConnectorForm) Get() *FacebookAdsConnectorForm {
	return v.value
}

func (v *NullableFacebookAdsConnectorForm) Set(val *FacebookAdsConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookAdsConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookAdsConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookAdsConnectorForm(val *FacebookAdsConnectorForm) *NullableFacebookAdsConnectorForm {
	return &NullableFacebookAdsConnectorForm{value: val, isSet: true}
}

func (v NullableFacebookAdsConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookAdsConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
